'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _web3_tools = require('../utils/web3_tools');

var _Pool = require('../contracts/Pool.json');

var _Pool2 = _interopRequireDefault(_Pool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Inc.
Email: tech@ambrosus.io

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var PoolActions = function () {
  function PoolActions(web3, poolsStoreWrapper) {
    (0, _classCallCheck3.default)(this, PoolActions);

    this.web3 = web3;
    this.poolsStoreWrapper = poolsStoreWrapper;
  }

  (0, _createClass3.default)(PoolActions, [{
    key: 'getList',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var count, pools, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, address, contract, name, id, active, totalStake;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.poolsStoreWrapper.getPoolsCount();

              case 2:
                count = _context.sent;
                _context.next = 5;
                return this.poolsStoreWrapper.getPools(0, count);

              case 5:
                pools = _context.sent;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 9;
                _iterator = pools[Symbol.iterator]();

              case 11:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 32;
                  break;
                }

                address = _step.value;
                _context.next = 15;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 15:
                contract = _context.sent;
                _context.next = 18;
                return contract.methods.name().call();

              case 18:
                name = _context.sent;
                _context.next = 21;
                return contract.methods.id().call();

              case 21:
                id = _context.sent;
                _context.next = 24;
                return contract.methods.active().call();

              case 24:
                active = _context.sent;
                _context.next = 27;
                return contract.methods.totalStake().call();

              case 27:
                totalStake = _context.sent;

                console.log(id, active ? 'active' : '      ', name, address, this.web3.utils.fromWei(totalStake, 'ether'));

              case 29:
                _iteratorNormalCompletion = true;
                _context.next = 11;
                break;

              case 32:
                _context.next = 38;
                break;

              case 34:
                _context.prev = 34;
                _context.t0 = _context['catch'](9);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 38:
                _context.prev = 38;
                _context.prev = 39;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 41:
                _context.prev = 41;

                if (!_didIteratorError) {
                  _context.next = 44;
                  break;
                }

                throw _iteratorError;

              case 44:
                return _context.finish(41);

              case 45:
                return _context.finish(38);

              case 46:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[9, 34, 38, 46], [39,, 41, 45]]);
      }));

      function getList() {
        return _ref.apply(this, arguments);
      }

      return getList;
    }()
  }, {
    key: 'activate',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context2.sent;
                _context2.t0 = console;
                _context2.next = 6;
                return contract.methods.activate().send({ gas: _web3_tools.DEFAULT_GAS, value: value, from: this.web3.eth.defaultAccount });

              case 6:
                _context2.t1 = _context2.sent;

                _context2.t0.log.call(_context2.t0, _context2.t1);

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function activate(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return activate;
    }()
  }, {
    key: 'deactivate',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(address) {
        var contract;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context3.sent;
                _context3.t0 = console;
                _context3.next = 6;
                return contract.methods.deactivate().send({ gas: _web3_tools.DEFAULT_GAS, from: this.web3.eth.defaultAccount });

              case 6:
                _context3.t1 = _context3.sent;

                _context3.t0.log.call(_context3.t0, _context3.t1);

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function deactivate(_x3) {
        return _ref3.apply(this, arguments);
      }

      return deactivate;
    }()
  }, {
    key: 'stake',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context4.sent;
                _context4.t0 = console;
                _context4.next = 6;
                return contract.methods.stake().send({ gas: _web3_tools.DEFAULT_GAS, value: value, from: this.web3.eth.defaultAccount });

              case 6:
                _context4.t1 = _context4.sent;

                _context4.t0.log.call(_context4.t0, _context4.t1);

              case 8:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function stake(_x4, _x5) {
        return _ref4.apply(this, arguments);
      }

      return stake;
    }()
  }, {
    key: 'unstake',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context5.sent;
                _context5.t0 = console;
                _context5.next = 6;
                return contract.methods.unstake(value).send({ gas: _web3_tools.DEFAULT_GAS, from: this.web3.eth.defaultAccount });

              case 6:
                _context5.t1 = _context5.sent;

                _context5.t0.log.call(_context5.t0, _context5.t1);

              case 8:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function unstake(_x6, _x7) {
        return _ref5.apply(this, arguments);
      }

      return unstake;
    }()
  }, {
    key: 'ownerUnstake',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(address) {
        var contract;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context6.sent;
                _context6.t0 = console;
                _context6.next = 6;
                return contract.methods.ownerUnstake().send({ gas: _web3_tools.DEFAULT_GAS, from: this.web3.eth.defaultAccount });

              case 6:
                _context6.t1 = _context6.sent;

                _context6.t0.log.call(_context6.t0, _context6.t1);

              case 8:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function ownerUnstake(_x8) {
        return _ref6.apply(this, arguments);
      }

      return ownerUnstake;
    }()
  }]);
  return PoolActions;
}();

exports.default = PoolActions;